/* stack.c generated by valac 0.28.1, the Vala compiler
 * generated from stack.vala, do not modify */

/*   FILE: stack.vala -- A stack
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 04 December 2013 
 *
 * Copyright (c) 2013 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <gee.h>


#define TYPE_STACK (stack_get_type ())
#define STACK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STACK, Stack))
#define STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STACK, StackClass))
#define IS_STACK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STACK))
#define IS_STACK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STACK))
#define STACK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STACK, StackClass))

typedef struct _Stack Stack;
typedef struct _StackClass StackClass;
typedef struct _StackPrivate StackPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Stack {
	GObject parent_instance;
	StackPrivate * priv;
};

struct _StackClass {
	GObjectClass parent_class;
};

struct _StackPrivate {
	GType t_type;
	GBoxedCopyFunc t_dup_func;
	GDestroyNotify t_destroy_func;
	GeeArrayList* list;
};


static gpointer stack_parent_class = NULL;

GType stack_get_type (void) G_GNUC_CONST;
#define STACK_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_STACK, StackPrivate))
enum  {
	STACK_DUMMY_PROPERTY,
	STACK_T_TYPE,
	STACK_T_DUP_FUNC,
	STACK_T_DESTROY_FUNC
};
Stack* stack_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
Stack* stack_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func);
gsize stack_size (Stack* self);
void stack_push (Stack* self, gconstpointer item);
gpointer stack_peek (Stack* self);
gpointer stack_pop (Stack* self);
static void stack_finalize (GObject* obj);
static void _vala_stack_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_stack_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);


Stack* stack_construct (GType object_type, GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func) {
	Stack * self = NULL;
	GeeArrayList* _tmp0_ = NULL;
	self = (Stack*) g_object_new (object_type, NULL);
	self->priv->t_type = t_type;
	self->priv->t_dup_func = t_dup_func;
	self->priv->t_destroy_func = t_destroy_func;
	_tmp0_ = gee_array_list_new (t_type, (GBoxedCopyFunc) t_dup_func, t_destroy_func, NULL, NULL, NULL);
	_g_object_unref0 (self->priv->list);
	self->priv->list = _tmp0_;
	return self;
}


Stack* stack_new (GType t_type, GBoxedCopyFunc t_dup_func, GDestroyNotify t_destroy_func) {
	return stack_construct (TYPE_STACK, t_type, t_dup_func, t_destroy_func);
}


gsize stack_size (Stack* self) {
	gsize result = 0UL;
	GeeArrayList* _tmp0_ = NULL;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	g_return_val_if_fail (self != NULL, 0UL);
	_tmp0_ = self->priv->list;
	_tmp1_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp0_);
	_tmp2_ = _tmp1_;
	result = (gsize) _tmp2_;
	return result;
}


void stack_push (Stack* self, gconstpointer item) {
	GeeArrayList* _tmp0_ = NULL;
	gconstpointer _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = item;
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp0_, _tmp1_);
}


gpointer stack_peek (Stack* self) {
	gpointer result = NULL;
	GeeArrayList* _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gpointer _tmp4_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->list;
	_tmp1_ = self->priv->list;
	_tmp2_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_list_get ((GeeAbstractList*) _tmp0_, _tmp3_ - 1);
	result = _tmp4_;
	return result;
}


gpointer stack_pop (Stack* self) {
	gpointer result = NULL;
	gpointer item = NULL;
	gpointer _tmp0_ = NULL;
	GeeArrayList* _tmp1_ = NULL;
	GeeArrayList* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	gpointer _tmp5_ = NULL;
	gpointer _tmp6_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = stack_peek (self);
	item = _tmp0_;
	_tmp1_ = self->priv->list;
	_tmp2_ = self->priv->list;
	_tmp3_ = gee_abstract_collection_get_size ((GeeCollection*) _tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp1_, _tmp4_ - 1);
	_tmp6_ = _tmp5_;
	((_tmp6_ == NULL) || (self->priv->t_destroy_func == NULL)) ? NULL : (_tmp6_ = (self->priv->t_destroy_func (_tmp6_), NULL));
	result = item;
	return result;
}


static void stack_class_init (StackClass * klass) {
	stack_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (StackPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_stack_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_stack_set_property;
	G_OBJECT_CLASS (klass)->finalize = stack_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_T_TYPE, g_param_spec_gtype ("t-type", "type", "type", G_TYPE_NONE, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_T_DUP_FUNC, g_param_spec_pointer ("t-dup-func", "dup func", "dup func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), STACK_T_DESTROY_FUNC, g_param_spec_pointer ("t-destroy-func", "destroy func", "destroy func", G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
}


static void stack_instance_init (Stack * self) {
	self->priv = STACK_GET_PRIVATE (self);
}


static void stack_finalize (GObject* obj) {
	Stack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_STACK, Stack);
	_g_object_unref0 (self->priv->list);
	G_OBJECT_CLASS (stack_parent_class)->finalize (obj);
}


GType stack_get_type (void) {
	static volatile gsize stack_type_id__volatile = 0;
	if (g_once_init_enter (&stack_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (StackClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) stack_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Stack), 0, (GInstanceInitFunc) stack_instance_init, NULL };
		GType stack_type_id;
		stack_type_id = g_type_register_static (G_TYPE_OBJECT, "Stack", &g_define_type_info, 0);
		g_once_init_leave (&stack_type_id__volatile, stack_type_id);
	}
	return stack_type_id__volatile;
}


static void _vala_stack_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	Stack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STACK, Stack);
	switch (property_id) {
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_stack_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	Stack * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_STACK, Stack);
	switch (property_id) {
		case STACK_T_TYPE:
		self->priv->t_type = g_value_get_gtype (value);
		break;
		case STACK_T_DUP_FUNC:
		self->priv->t_dup_func = g_value_get_pointer (value);
		break;
		case STACK_T_DESTROY_FUNC:
		self->priv->t_destroy_func = g_value_get_pointer (value);
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}



